"%+%" <- function (a, b) {
    if (is.numeric(a) && is.numeric(b)) out=sum(a,b)
    else out=paste(a,b,sep="")
    out
}
has.intercept<-function(object,...) UseMethod("has.intercept",object)
has.intercept.formula <- function(x)as.logical(attr(terms(x),'intercept'))
rhs<-function (x, ...) UseMethod("rhs",x)
rhs.formula<-function(formula){
  fm  <- strsplit(as.character(paste(deparse(formula),collapse="")),"~")[[1]]
  rhs <- unlist(strsplit(fm[2],""))
  rhs <- rhs[rhs != " "]
  rhs <- as.formula(paste(c("~",rhs),collapse=""))
  rhs
}
# as.double(x) in older versions of R when using .C(DUP = FALSE) made duplicate copy of x
# in addition, even if x is a 'double', since x has attributes (dim(x)) as.double(x) duplicates
.as.double <- function(x, stripAttributes=FALSE){
	if(!stripAttributes){
		if(is.double(x)) return(x)   # no duplicate copy
		storage.mode(x) <- 'double'  # yes duplicate copy
		return(x)
	}
	return(as.double(x))             # duplicate copy if has attributes or not double 
}



# combine<-function (x, ...) UseMethod("combine",x)
# combine.formula <- function(formula1,formula2){
  # fm1  <- strsplit(as.character(paste(deparse(formula1),collapse="")),"~")[[1]]
  # lhs1 <- unlist(strsplit(fm1[1],""))
  # lhs1 <- lhs1[lhs1 != " "]
  # rhs1 <- unlist(strsplit(fm1[2],""))
  # rhs1 <- rhs1[rhs1 != " "]
  
  # fm2  <- strsplit(as.character(paste(deparse(formula2),collapse="")),"~")[[1]]
  # lhs2 <- unlist(strsplit(fm2[1],""))
  # lhs2 <- lhs2[lhs2 != " "]
  # rhs2 <- unlist(strsplit(fm2[2],""))
  # rhs2 <- rhs2[rhs2 != " "]  
  # paste(c(lhs1,"+",lhs2,"~",rhs1,"+",rhs2),collapse="")
# }

# From package Rloqo, needed to pass control arguments to C-code when tuning
control.loqo <- function(
bound = 10,inf = 1e6,margin = .05,maxiter = 100,sigf = 7,solver = c("ldl", "lu", "qr"),verb = FALSE,control = NULL)
{
	default <- list(sigf = sigf,inf = inf,maxiter = maxiter,margin = margin,bound = bound,solver = solver[1],verb = verb)
	control <- c(control,default[setdiff(names(default),names(control))]) # arguments in 'control' overwrite default
	control <- control[order(names(control))]	
	control
}
# usage: 
# default <- control.loqo()
# old.control <- control.loqo(margin = 1e-8) # 'margin' is different from default
# new.control <- control.loqo(control = old.control,maxit = 1) # keep old.control but change 'maxit' 
control.ipop <- control.loqo


control.rts <- function(maxit = 100,tol = 1e-6,verbose = FALSE,control = NULL)
{
	default <- list(maxit = maxit,tol = tol,verbose = as.numeric(verbose))
	control <- c(control,default[setdiff(names(default),names(control))]) # arguments in 'control' overwrite default
	control <- control[order(names(control))]	
	control
}
