
#ifndef LOQO_h
#define LOQO_h
typedef enum {LOQO_CONVERGED = 0,LOQO_PRIMAL_DUAL_INFEASIBLE = 1,LOQO_PRIMAL_INFEASIBLE = 2,
LOQO_DUAL_INFEASIBLE = 3, LOQO_PRIMAL_SOLUTION_OUT_OF_BOUNDS = 4,
LOQO_PRIMAL_UNBOUNDED = 5, LOQO_DUAL_UNBOUNDED = 6,
LOQO_SLOW_CONVERGENCE = 7,
LOQO_LOGIC_ERROR = 8,
LOQO_LAPACK_ERROR = 9,
LOQO_MEMORY_ALLOCATION_FAILURE = 10 
}LOQO_STATUS;
extern const char* LOQO_STATUS_NAMES[11];
typedef enum {LDL = 0,LU = 1,QR = 2}LAPACK_SOLVER;

typedef struct loqo_control{
LAPACK_SOLVER lapack_solver;
int maxiter; 
double sigfig_max;
double margin; 
double bound; 
double inf;
int verbose;
}LOQO_CONTROL;

typedef struct loqo_arg{
// input
int n;
double* c;                // length n linear term 
double* H;                // n x n Hessian 
double* lo;               // lo <= x
double* up;               // x <= up
int m; 
double* A;       //m x n,  b <= A * x <= b + r
double* b;  
double* r;
int double_buffer_size;
double* double_buffer;

//output
double* primal;
double* dual;
double primal_obj;
double dual_obj;
int iterations;
int status;
int error_code;

}LOQO_ARG;
#endif
			 
void get_buffer_size_loqo(int solver,int update_solver,int m,int n,int* dsize,int* isize);
void init_control_loqo(LOQO_CONTROL* control);
void print_control_loqo(LOQO_CONTROL* control);
void print_arg_loqo(LOQO_ARG* arg,int print_hessian);
void loqo(LOQO_ARG* arg,LOQO_CONTROL* control);
void R_loqo(int* _n,double* linear, double* hessian, double* l, double* u,
int* _m, double* constr_mat, double* constr_vec1,  double* constr_vec2, 
int* verbose,int* lapack_solver,int* maxiter,
double* sigfig_max, double* margin, double* bound,double* inf,
int* _dbuffer_size,double* _dbuffer,
double* primal,double* dual,double* _primal_obj,double* _dual_obj,
int* iterations,int* status,int* error_code);

